# md5crypt.py — Restored for Python 3 by sovereign command

from hashlib import md5

MAGIC = '$1$'
ITOA64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

def to64(v, n):
    ret = ''
    while n > 0:
        ret += ITOA64[v & 0x3f]
        v >>= 6
        n -= 1
    return ret

def unix_md5_crypt(pw, salt, magic=MAGIC):
    if salt.startswith(magic):
        salt = salt[len(magic):]

    salt = salt.split('$', 1)[0][:8]

    ctx = pw + magic + salt
    final = md5((pw + salt + pw).encode('utf-8')).digest()

    for pl in range(len(pw), 0, -16):
        ctx += final[:min(pl, 16)].decode('latin1')

    i = len(pw)
    while i:
        ctx += chr(0) if i & 1 else pw[0]
        i >>= 1

    final = md5(ctx.encode('latin1')).digest()

    for i in range(1000):
        ctx1 = b''
        if i & 1:
            ctx1 += pw.encode('utf-8')
        else:
            ctx1 += final
        if i % 3:
            ctx1 += salt.encode('utf-8')
        if i % 7:
            ctx1 += pw.encode('utf-8')
        if i & 1:
            ctx1 += final
        else:
            ctx1 += pw.encode('utf-8')
        final = md5(ctx1).digest()

    rearranged = [
        (final[0] << 16) | (final[6] << 8) | final[12],
        (final[1] << 16) | (final[7] << 8) | final[13],
        (final[2] << 16) | (final[8] << 8) | final[14],
        (final[3] << 16) | (final[9] << 8) | final[15],
        (final[4] << 16) | (final[10] << 8) | final[5],
        final[11],
        ]

    passwd = ''.join(to64(val, 4) for val in rearranged[:5])
    passwd += to64(rearranged[5], 2)

    return f"{magic}{salt}${passwd}"

def apache_md5_crypt(pw, salt):
    return unix_md5_crypt(pw, salt, magic='$apr1$')

md5crypt = unix_md5_crypt
